- [HTTP request](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/update#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/update#body.PATH_PARAMETERS)
- [Query parameters](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/update#body.QUERY_PARAMETERS)
- [Request body](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/update#body.request_body)
- [Response body](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/update#body.response_body)
- [Authorization scopes](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/update#body.aspect)
- [Try it!](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/update#try-it)

Sets values in a range of a spreadsheet. The caller must specify the spreadsheet ID, range, and a `https://developers.google.com/workspace/sheets/api/reference/rest/v4/ValueInputOption`.

### HTTP request

`PUT https://sheets.googleapis.com/v4/spreadsheets/{spreadsheetId}/values/{range}`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `spreadsheetId` | `string` The ID of the spreadsheet to update. |
| `range` | `string` The [A1 notation](https://developers.google.com/workspace/sheets/api/guides/concepts#cell) of the values to update. |

### Query parameters

| Parameters ||
|---|---|
| `valueInputOption` | ``enum (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/ValueInputOption`)`` How the input data should be interpreted. |
| `includeValuesInResponse` | `boolean` Determines if the update response should include the values of the cells that were updated. By default, responses do not include the updated values. If the range to write was larger than the range actually written, the response includes all values in the requested range (excluding trailing empty rows and columns). |
| `responseValueRenderOption` | ``enum (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/ValueRenderOption`)`` Determines how values in the response should be rendered. The default render option is `https://developers.google.com/workspace/sheets/api/reference/rest/v4/ValueRenderOption`. |
| `responseDateTimeRenderOption` | ``enum (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/DateTimeRenderOption`)`` Determines how dates, times, and durations in the response should be rendered. This is ignored if `https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/update#body.QUERY_PARAMETERS.response_value_render_option` is `https://developers.google.com/workspace/sheets/api/reference/rest/v4/ValueRenderOption`. The default dateTime render option is `https://developers.google.com/workspace/sheets/api/reference/rest/v4/DateTimeRenderOption`. |

### Request body

The request body contains an instance of `https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values#ValueRange`.

### Response body

If successful, the response body contains an instance of `https://developers.google.com/workspace/sheets/api/reference/rest/v4/UpdateValuesResponse`.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/drive`
- `https://www.googleapis.com/auth/drive.file`
- `https://www.googleapis.com/auth/spreadsheets`

For more information, see the [Authorization guide](https://developers.google.com/workspace/guides/configure-oauth-consent).